function list = defaultlutblklist
% Abstract:
%   Find all opened Simulink systems.
%   The result is a Java Hashtable object. The key is the string concatination
%   of BlockType and MaskType from a block.
%

% Copyright 2003 The MathWorks, Inc.

list = java.util.Hashtable;

% setup the list structure in the following format:
% { [BlockTypeName///MaskTypeName], {BreakPointNames, TableNames};
%   ...}
blkInfo = { ...
% 1
    ['Lookup',    '///', ''],{{'InputValues'},{''},{''},{'OutputValues'}}; ...
% 11
    ['Lookup2D',  '///', ''],{{'x','y'},{''},{''},{'t'}}; ...
% 2
    ['SubSystem',  '///', 'Lookup Table (2-D)'],{{'x','y'},{''},{''},{'t'}}; ...
% 3
    ['S-Function', '///', 'LookupNDInterp'], ...
    {{'bp1','bp2','bp3','bp4','bpcell'}, ...
     {'numDimsPopupSelect'},{'explicitNumDims'}, {'tableData'}}; ...
% 4
    ['S-Function', '///', 'LookupNDDirect'], ...
    {{''},{'masktabDims'},{'explicitNumDims'}, {'mxTable'}}; ...
% 5
    ['S-Function', '///', 'LookupIdxSearch'], {{'bpData'},{''},{''}, {''}}; ...
% 6 
    ['S-Function', '///', 'LookupNDInterpIdx'], ...
    {{''},{'numDimsPopupSelect'},{'explicitNumDims'}, {'table'}}; ...
% 7
    ['S-Function', '///', 'S-function: sfun_directlook'], ...
    {{'XVECT'},{''},{''},{'YVECT'}}; ...
% 8
    ['S-Function', '///', 'S-function: sftable2'], ...
    {{'xindex_idx', 'yindex_idx'},{''},{''}, {'table_idx'}}; ...
% 9 
    ['SubSystem',  '///', 'Repeating table'], ...
    {{'rep_seq_t'},{''},{''}, {'rep_seq_y'}}; ...
% 10
    ['S-Function', '///', 'Fixed-Point Look-Up Table Dynamic'], ...
    {{''},{''},{''},{''}}; ...
	  };

for i = 1:length(blkInfo)
  list.put(blkInfo{i,1}, blkInfo{i,2});
end

% end
            

