%   make_formatters.m
%
%   File to create the formatter objects used for 
%   documentation.

%   Bill Aldrich
%   Copyright 1990-2003 The MathWorks, Inc.
%   $Revision: 1.29.4.3 $  $Date: 2004/04/15 00:37:35 $


% ================ Stateflow Messages =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_ACTIVE_ON_ENTRY', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_ENTER_FROM_TRANSITION', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_CHILDREN', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_ACTIVE_ON_ENTRY', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_PARENT_AFTER_ENTRY', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_PARENT_AFTER_SIB_ENTRY', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_AFTER_ENTRY_EVENT', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_ENTER_FROM_OUTSIDE', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_PREV_ACTIVE_CHILD', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_HIST_CHILD_CALL', ...
        '.abbreviation',        'History test', ...
        '.summary.formatStr',   'History substate', ...
        '.detail.formatStr',    'Previously active substate entered due to history' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_AFTER_CHILD_ENTRY', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_CHILD_FROM_HIST', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_ENTER_SET_FROM_OUTSIDE', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_AFTER_DEFAULT', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_BEFORE_DURING', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_CHILDREN_DURING', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );
        
h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_STATE_ON_DECISION', ...
        '.abbreviation',        'On Decision', ...
        '.summary.formatStr',   'Event "%s"', ...
        '.detail.formatStr',    'Trigger event "%s"' ...
        );
        


% ================ Transition Messages =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_TRANSITION_TEST', ...
        '.abbreviation',        'Test', ...
        '.summary.formatStr',   'Transition', ...
        '.detail.formatStr',    'Transition trigger expression' ...
        );
h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_TRANS_PRED', ...
        '.abbreviation',        'CND[i]', ...
        '.summary.formatStr',   '"%s"', ...
        '.detail.formatStr',    'Condition %d1, "%s"' ...
        );
h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_ACTIVE_CHILD_CALL', ...
        '.abbreviation',        'Child executed', ...
        '.summary.formatStr',   'Executed substate', ...
        '.detail.formatStr',    'Substate executed' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_BEFORE_EXIT', ...
        '.abbreviation',        'Child exit', ...
        '.summary.formatStr',   'Indirectly exited substate', ...
        '.detail.formatStr',    'Substate exited when parent exits' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_ACTIVE_CHILD_AT_EXIT', ...
        '.abbreviation',        'Child exit', ...
        '.summary.formatStr',   'Indirectly exited substate', ...
        '.detail.formatStr',    'Substate exited when parent exits' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_ACTIVE_CHILD_EXIT', ...
        '.abbreviation',        'Child exit', ...
        '.summary.formatStr',   'Indirectly exited substate', ...
        '.detail.formatStr',    'Substate exited when parent exits' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SF_INACTIVE_AFTER_CHILD_EXIT', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

% ================ Absolute Value Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_ABSVAL_SCAL', ...
        '.abbreviation',        'U<0', ...
        '.summary.formatStr',   'U < 0', ...
        '.detail.formatStr',    'input < 0' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_ABSVAL_VECT', ...
        '.abbreviation',        'U<0', ...
        '.summary.formatStr',   'U[%d] < 0', ...
        '.detail.formatStr',    'input(%d) < 0' ...
        );

% ================ Relay Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RELAY_ON_SCAL', ...
        '.abbreviation',        'Turn On', ...
        '.summary.formatStr',   'U >= OnThresh', ...
        '.detail.formatStr',    'input >= switch on threshold' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RELAY_ON_VECTU', ...
        '.abbreviation',        'Turn On', ...
        '.summary.formatStr',   'U[%d] >= OnThresh', ...
        '.detail.formatStr',    'input(%d) >= on threshold' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RELAY_ON_VECTP', ...
        '.abbreviation',        'Turn On', ...
        '.summary.formatStr',   'U >= OnThresh[%d]', ...
        '.detail.formatStr',    'input >= on threshold(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RELAY_ON_VECTUP', ...
        '.abbreviation',        'Turn On', ...
        '.summary.formatStr',   'U[%d] >= OnThresh[%d]', ...
        '.detail.formatStr',    'input(%d) >= on threshold(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RELAY_OFF_SCAL', ...
        '.abbreviation',        'Turn Off', ...
        '.summary.formatStr',   'U <= OffThresh', ...
        '.detail.formatStr',    'input <= off threshold' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RELAY_OFF_VECTU', ...
        '.abbreviation',        'Turn Off', ...
        '.summary.formatStr',   'U[%d] <= OffThresh', ...
        '.detail.formatStr',    'input(%d) <= off threshold' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RELAY_OFF_VECTP', ...
        '.abbreviation',        'Turn Off', ...
        '.summary.formatStr',   'U <= OffThresh[%d]', ...
        '.detail.formatStr',    'input <= off threshold(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RELAY_OFF_VECTUP', ...
        '.abbreviation',        'Turn Off', ...
        '.summary.formatStr',   'U[%d] <= OffThresh[%d]', ...
        '.detail.formatStr',    'input(%d) <= off threshold(%d)' ...
        );

% ================ Saturate Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SATURATE_UL_SCAL', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'U >= UL', ...
        '.detail.formatStr',    'input >= upper limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SATURATE_UL_VECTU', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'U[%d] >= UL', ...
        '.detail.formatStr',    'input(%d) >= upper limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SATURATE_UL_VECTP', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'U >= UL[%d]', ...
        '.detail.formatStr',    'input >= upper limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SATURATE_UL_VECTUP', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'U[%d] >= UL[%d]', ...
        '.detail.formatStr',    'input(%d) >= upper limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SATURATE_LL_SCAL', ...
        '.abbreviation',        'Above LL', ...
        '.summary.formatStr',   'U > LL', ...
        '.detail.formatStr',    'input > lower limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SATURATE_LL_VECTU', ...
        '.abbreviation',        'Above LL', ...
        '.summary.formatStr',   'U[%d] > LL', ...
        '.detail.formatStr',    'input(%d) > lower limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SATURATE_LL_VECTP', ...
        '.abbreviation',        'Above LL', ...
        '.summary.formatStr',   'U > LL[%d]', ...
        '.detail.formatStr',    'input > lower limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SATURATE_LL_VECTUP', ...
        '.abbreviation',        'Above LL', ...
        '.summary.formatStr',   'U[%d] > LL[%d]', ...
        '.detail.formatStr',    'input(%d) > lower limit(%d)' ...
        );

% ================ Discrete-Time Integrator Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_RESET_SCAL', ...
        '.abbreviation',        'Reset', ...
        '.summary.formatStr',   'Reset', ...
        '.detail.formatStr',    'Reset' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_RESET_VECT', ...
        '.abbreviation',        'Reset[i]', ...
        '.summary.formatStr',   'Reset[%d]', ...
        '.detail.formatStr',    'Reset(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_UL_SCAL', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'X >= UL', ...
        '.detail.formatStr',    'integration result >= upper limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_UL_VECTU', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'X[%d] >= UL', ...
        '.detail.formatStr',    'integration result(%d) >= upper limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_UL_VECTP', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'X >= UL[%d]', ...
        '.detail.formatStr',    'integration result >= upper limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_UL_VECTUP', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'X[%d] >= UL[%d]', ...
        '.detail.formatStr',    'integration result(%d) >= upper limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_LL_SCAL', ...
        '.abbreviation',        'Below LL', ...
        '.summary.formatStr',   'X <= LL', ...
        '.detail.formatStr',    'integration result <= lower limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_LL_VECTU', ...
        '.abbreviation',        'Below LL', ...
        '.summary.formatStr',   'X[%d] <= LL', ...
        '.detail.formatStr',    'integration result(%d) <= lower limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_LL_VECTP', ...
        '.abbreviation',        'Below LL', ...
        '.summary.formatStr',   'X <= LL[%d]', ...
        '.detail.formatStr',    'integration result <= lower limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_DINTEGRATOR_LL_VECTUP', ...
        '.abbreviation',        'Below LL', ...
        '.summary.formatStr',   'X[%d] <= LL[%d]', ...
        '.detail.formatStr',    'integration result(%d) <= lower limit(%d)' ...
        );

% ================ Rate Limiter Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RATELIMITER_UL_SCAL', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'X >= UL', ...
        '.detail.formatStr',    'slew rate >= upper limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RATELIMITER_UL_VECTU', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'X[%d] >= UL', ...
        '.detail.formatStr',    'slew rate(%d) >= upper limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RATELIMITER_UL_VECTP', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'X >= UL[%d]', ...
        '.detail.formatStr',    'slew rate >= upper limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RATELIMITER_UL_VECTUP', ...
        '.abbreviation',        'Above UL', ...
        '.summary.formatStr',   'X[%d] >= UL[%d]', ...
        '.detail.formatStr',    'slew rate(%d) >= upper limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RATELIMITER_LL_SCAL', ...
        '.abbreviation',        'Below LL', ...
        '.summary.formatStr',   'X <= LL', ...
        '.detail.formatStr',    'slew rate <= lower limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RATELIMITER_LL_VECTU', ...
        '.abbreviation',        'Below LL', ...
        '.summary.formatStr',   'X[%d] <= LL', ...
        '.detail.formatStr',    'slew rate(%d) <= lower limit' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RATELIMITER_LL_VECTP', ...
        '.abbreviation',        'Below LL', ...
        '.summary.formatStr',   'X <= LL[%d]', ...
        '.detail.formatStr',    'slew rate <= lower limit(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_RATELIMITER_LL_VECTUP', ...
        '.abbreviation',        'Below LL', ...
        '.summary.formatStr',   'X[%d] <= LL[%d]', ...
        '.detail.formatStr',    'slew rate(%d) <= lower limit(%d)' ...
        );


% ================ fcn Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_FCN_CONDITION', ...
        '.abbreviation',        'condition', ...
        '.summary.formatStr',   '"%s"', ...
        '.detail.formatStr',    'condition "%s"' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_FCN_TEST', ...
        '.abbreviation',        'expression', ...
        '.summary.formatStr',   'Expression', ...
        '.detail.formatStr',    'Logical expression value' ...
        );

% ================ Logic Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_LOGIC_SCAL', ...
        '.abbreviation',        'Porti', ...
        '.summary.formatStr',   'port%d', ...
        '.detail.formatStr',    'input port %d' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_LOGIC_VECT', ...
        '.abbreviation',        'INi[J]', ...
        '.summary.formatStr',   'port%d1[%d2]', ...
        '.detail.formatStr',    'input port%d1(%d2)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_LOGIC_SCAL_OUT', ...
        '.abbreviation',        'OUT', ...
        '.summary.formatStr',   'Output', ...
        '.detail.formatStr',    'expression for output' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_LOGIC_VECT_OUT', ...
        '.abbreviation',        'OUT[i]', ...
        '.summary.formatStr',   'Output[%d1]', ...
        '.detail.formatStr',    'expression for output(%d1)' ...
        );

% ================ Combinatoric Logic Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_CMBLOGIC_SCAL', ...
        '.abbreviation',        'IF (in)', ...
        '.summary.formatStr',   'IF (input)', ...
        '.detail.formatStr',    'input logical value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_CMBLOGIC_VECT', ...
        '.abbreviation',        'SWITCH (IN)', ...
        '.summary.formatStr',   'Equivalent index', ...
        '.detail.formatStr',    'integer index value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_CMBLOGIC_ELM', ...
        '.abbreviation',        'IN[i]', ...
        '.summary.formatStr',   'input[%d]', ...
        '.detail.formatStr',    'input(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_CMBLOGIC_OUT', ...
        '.abbreviation',        'Case i', ...
        '.summary.formatStr',   '%d1 (input=%s)', ...
        '.detail.formatStr',    'calculated to %d1 based on inputs %s (output row %d2)' ...
        );

% =================== If Block ==========================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_IF_SING_IF', ...
        '.abbreviation',        'IF', ...
        '.summary.formatStr',   'IF', ...
        '.detail.formatStr',    'input logical value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_IF_MULT_IF', ...
        '.abbreviation',        'IF', ...
        '.summary.formatStr',   'Input%d', ...
        '.detail.formatStr',    'input %d "if" condition' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_IF_MULT_ELSEIF', ...
        '.abbreviation',        'ElseIF', ...
        '.summary.formatStr',   'Else IF #%d', ...
        '.detail.formatStr',    'input %d "elseif" condition' ...
        );

% =================== For Block ==========================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_FOR_CHECK', ...
        '.abbreviation',        'FOR', ...
        '.summary.formatStr',   'Loop test', ...
        '.detail.formatStr',    'loop condition' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_LOOPEXEC', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   'executed', ...
        '.detail.formatStr',    'executed' ...
        );


% =================== While Block ==========================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_WHILE_WHILETEST', ...
        '.abbreviation',        'WHILE', ...
        '.summary.formatStr',   'While condition', ...
        '.detail.formatStr',    'While loop condition' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_WHILE_DOWHILETEST', ...
        '.abbreviation',        'DO-WHILE', ...
        '.summary.formatStr',   'Do-While condition', ...
        '.detail.formatStr',    'Do-While loop condition' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MGG_SL_WHILE_MAXITERS', ...
        '.abbreviation',        'MX ITER', ...
        '.summary.formatStr',   'Max iterations', ...
        '.detail.formatStr',    'maximum iterations exceeded' ...
        );

% =================== Min/Max Block ==========================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MINMAX_SCAL', ...
        '.abbreviation',        'Out LGC', ...
        '.summary.formatStr',   'Output', ...
        '.detail.formatStr',    'Logic to determine output' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MINMAX_VECT', ...
        '.abbreviation',        'OUTi LGC', ...
        '.summary.formatStr',   'Output[%d]', ...
        '.detail.formatStr',    'Logic to determine output element %d' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MIN_IDX', ...
        '.abbreviation',        'INi', ...
        '.summary.formatStr',   'input %d', ...
        '.detail.formatStr',    'input %d is the minimum' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MAX_IDX', ...
        '.abbreviation',        'INi', ...
        '.summary.formatStr',   'input %d', ...
        '.detail.formatStr',    'input %d is the maximum' ...
        );

% ================ Subsystem Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_FCALL', ...
        '.abbreviation',        'FCALL', ...
        '.summary.formatStr',   'Function call', ...
        '.detail.formatStr',    'Function call' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_ENBLS', ...
        '.abbreviation',        'IF (ENBL)', ...
        '.summary.formatStr',   'Enable', ...
        '.detail.formatStr',    'enable logical value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_ENBLV', ...
        '.abbreviation',        'IF (ENBL)', ...
        '.summary.formatStr',   'Vector enable', ...
        '.detail.formatStr',    'subsystem enable expression, (enable(1) || enable(2) || ...)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_TRIGS', ...
        '.abbreviation',        'IF (TRIG)', ...
        '.summary.formatStr',   'Trigger', ...
        '.detail.formatStr',    'trigger edge occurred' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_TRIGV', ...
        '.abbreviation',        'IF (TRIG)', ...
        '.summary.formatStr',   'Vector trigger', ...
        '.detail.formatStr',    'trigger edge occurred' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_ENBLS_TRIGS', ...
        '.abbreviation',        'IF (TRIG & ENBL)', ...
        '.summary.formatStr',   'IF (TRIG & ENBL)', ...
        '.detail.formatStr',    'trigger edge occurred while enabled' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_ENBLS_TRIGV', ...
        '.abbreviation',        'IF (TRIG & ENBL)', ...
        '.summary.formatStr',   'IF (any TRIG && ENBL)', ...
        '.detail.formatStr',    'trigger edge occurred while enabled' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_ENBLV_TRIGS', ...
        '.abbreviation',        'IF (TRIG & ENBL)', ...
        '.summary.formatStr',   'IF (TRIG && any ENBL)', ...
        '.detail.formatStr',    'trigger edge occurred while (enable(1) || enable(2) || ...) is true' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_ENBLV_TRIGV', ...
        '.abbreviation',        'IF (TRIG & ENBL)', ...
        '.summary.formatStr',   'IF (any TRIG && any ENBL)', ...
        '.detail.formatStr',    'trigger edge occurred while (enable(1) || enable(2) || ...) is true' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_ENBL_COND', ...
        '.abbreviation',        'ENBL', ...
        '.summary.formatStr',   'Enable', ...
        '.detail.formatStr',    'enable' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_ENBLV_COND', ...
        '.abbreviation',        'ENBL[i]', ...
        '.summary.formatStr',   'Enable[%d]', ...
        '.detail.formatStr',    'enable(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_TRIG_COND', ...
        '.abbreviation',        'TRIG', ...
        '.summary.formatStr',   'Trigger', ...
        '.detail.formatStr',    'trigger edge occured' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SUBSYS_TRIGV_COND', ...
        '.abbreviation',        'TRIG[i]', ...
        '.summary.formatStr',   'Trigger[%d]', ...
        '.detail.formatStr',    'trigger(%d) edge occured' ...
        );

% ================ Switch Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_BOOL_SCAL', ...
        '.abbreviation',        'IF TRIG', ...
        '.summary.formatStr',   'Switch trigger', ...
        '.detail.formatStr',    'logical trigger input' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_BOOL_VECT', ...
        '.abbreviation',        'If TRIG[i]', ...
        '.summary.formatStr',   'Switch trigger %d', ...
        '.detail.formatStr',    'logical trigger input(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_REAL_SCAL', ...
        '.abbreviation',        'TRIG > THRESH', ...
        '.summary.formatStr',   'TRIGGER >= THRESHOLD', ...
        '.detail.formatStr',    'trigger >= threshold' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_REAL_VECTU', ...
        '.abbreviation',        'TRIG[i] > THRESH', ...
        '.summary.formatStr',   'TRIGGER[%d] >= THRESHOLD', ...
        '.detail.formatStr',    'trigger(%d) >= threshold' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_REAL_VECTP', ...
        '.abbreviation',        'TRIG > THRESH[i]', ...
        '.summary.formatStr',   'TRIGGER >= THRESHOLD[%d]', ...
        '.detail.formatStr',    'trigger >= threshold(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_REAL_VECTUP', ...
        '.abbreviation',        'TRIG[i] > THRESH[i]', ...
        '.summary.formatStr',   'TRIGGER[%d] >= THRESHOLD[%d]', ...
        '.detail.formatStr',    'trigger(%d) >= threshold(%d)' ...
        );
h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_REAL_GT_SCAL', ...
        '.abbreviation',        'TRIG > THRESH', ...
        '.summary.formatStr',   'TRIGGER > THRESHOLD', ...
        '.detail.formatStr',    'trigger > threshold' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_REAL_GT_VECTU', ...
        '.abbreviation',        'TRIG[i] > THRESH', ...
        '.summary.formatStr',   'TRIGGER[%d] > THRESHOLD', ...
        '.detail.formatStr',    'trigger(%d) > threshold' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_REAL_GT_VECTP', ...
        '.abbreviation',        'TRIG > THRESH[i]', ...
        '.summary.formatStr',   'TRIGGER > THRESHOLD[%d]', ...
        '.detail.formatStr',    'trigger > threshold(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_REAL_GT_VECTUP', ...
        '.abbreviation',        'TRIG[i] > THRESH[i]', ...
        '.summary.formatStr',   'TRIGGER[%d] > THRESHOLD[%d]', ...
        '.detail.formatStr',    'trigger(%d) > threshold(%d)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_OUTCOME_T', ...
        '.abbreviation',        'T => IN1', ...
        '.summary.formatStr',   'true (out = in1)', ...
        '.detail.formatStr',    'true (output is from 1st input port)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWITCH_OUTCOME_F', ...
        '.abbreviation',        'F => IN3', ...
        '.summary.formatStr',   'false (out = in3)', ...
        '.detail.formatStr',    'false (output is from 3rd input port)' ...
        );
% ================ Switch-Case  Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_SWTCHCASE', ...
        '.abbreviation',        'Switch(in)', ...
        '.summary.formatStr',   'Switch input', ...
        '.detail.formatStr',    'truncated input' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MCG_SL_SWTCHCASE_OUTI', ...
        '.abbreviation',        'case i', ...
        '.summary.formatStr',   '%d1', ...
        '.detail.formatStr',    '= %d1 (input == %d2)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MCG_SL_SWTCHCASE_DFLT', ...
        '.abbreviation',        'default', ...
        '.summary.formatStr',   'default', ...
        '.detail.formatStr',    'default case' ...
        );

% ================ Multiport Switch Block =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MPSWITCH_OUTCOME_PORT', ...
        '.abbreviation',        'Case i', ...
        '.summary.formatStr',   'Case %d1 (out = in%d2)', ...
        '.detail.formatStr',    '= %d1 (output is from input port %d2)' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MPSWITCH_OUTCOME_ELMNT', ...
        '.abbreviation',        'Case i', ...
        '.summary.formatStr',   'Case %d1 (out = in[%d2])', ...
        '.detail.formatStr',    '= %d1 (output is from input(%d2))' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MPSWITCH_INT_SCAL_PORT', ...
        '.abbreviation',        'SWITCH(IN0)', ...
        '.summary.formatStr',   'Control input', ...
        '.detail.formatStr',    'integer input value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MPSWITCH_INT_SCAL_ELMNT', ...
        '.abbreviation',        'SWITCH(IN0)', ...
        '.summary.formatStr',   'Control input', ...
        '.detail.formatStr',    'integer input value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MPSWITCH_INT_VECT', ...
        '.abbreviation',        'SWITCH(IN0[i])', ...
        '.summary.formatStr',   'Control input[%d]', ...
        '.detail.formatStr',    'integer input(%d) value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MPSWITCH_REAL_SCAL_PORT', ...
        '.abbreviation',        'SWITCH(IN0)', ...
        '.summary.formatStr',   'Control input', ...
        '.detail.formatStr',    'truncated input value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MPSWITCH_REAL_SCAL_ELMNT', ...
        '.abbreviation',        'SWITCH(IN0)', ...
        '.summary.formatStr',   'Control input', ...
        '.detail.formatStr',    'truncated input value' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_SL_MPSWITCH_REAL_VECT', ...
        '.abbreviation',        'SWITCH(IN0[i])', ...
        '.summary.formatStr',   'Control input[%d]', ...
        '.detail.formatStr',    'truncated input(%d) value' ...
        );

% ================ Generic Outcome Messages =======================

h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_CALL', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   'executed', ...
        '.detail.formatStr',    'executed' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_IMPLICIT_DFLT', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   'implicit default', ...
        '.detail.formatStr',    'implicit default' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_EXPLICIT', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   'otherwise', ...
        '.detail.formatStr',    'otherwise' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_CASE', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   'Case %s', ...
        '.detail.formatStr',    'Case %s' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_GENERIC_TXT', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '%s', ...
        '.detail.formatStr',    '%s' ...
        );


h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_T', ...
        '.abbreviation',        'T', ...
        '.summary.formatStr',   'true', ...
        '.detail.formatStr',    'true' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_F', ...
        '.abbreviation',        'F', ...
        '.summary.formatStr',   'false', ...
        '.detail.formatStr',    'false' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_STATE', ...
        '.abbreviation',        'State i', ...
        '.summary.formatStr',   '%o', ...
        '.detail.formatStr',    'State %o' ...
        );

h = cv('new','formatter', '.keyNum', ...
		'MSG_OUT_BLOCK', ...
        '.abbreviation',        '', ...
        '.summary.formatStr',   '', ...
        '.detail.formatStr',    '' ...
        );

