% Simulink 4 demonstrations and samples.
%
% Models and demos that correspond to the demos included
% in the MATLAB "demo" facility are located in the
% subdirectories corresponding to their demo categories:
%
%   simnew      - New features in this release.
%   simfeatures - Demos of specific features.
%   simgeneral  - General model examples.
%   automotive  - Automotive examples.
%   aerospace   - Aerospace examples.
%
% Miscellaneous demonstration models:
%   multi       - Multivariate lines.
%   parmest     - Parameter estimation.
%   pops        - Population dynamics.
%   rlsest      - Adaptive control.
%   steps       - Effects of varying step size.
%
% Demonstration models for case studies #1,#2,#3 in the user's guide.
%   f14         - F-14 demos are located in the aero subdirectory.
%
%   ben2asys    - JHU/APL continuous benchmark, simple 13-state model
%   ben2bsys    - JHU/APL continuous benchmark, intermediate 42-state model.
%   ben2csys    - JHU/APL continuous benchmark, difficult 74-state model.
%   ben3asys    - JHU/APL sampled-data benchmark, simple 10-state model.
%   ben3bsys    - JHU/APL sampled-data benchmark, complex 29-state model.
%
% Demonstration scripts.
%   popdemo - Population dynamics.
%
% Execute the MATLAB command "demo simulink" to see a menu of all demos
% and models in this directory (except for case studies #1-3).  The
% demo menu is also available by opening the Demos block in the main
% Simulink block library (which is displayed by executing the command
% "simulink3").

% The routines below this line are available by typing their names
% at the MATLAB command line.
%
% Demonstration models of specialized blocks.
%   corrdemo    - Auto-correlator block.
%   fohdemo     - First order hold block.
%   lorenzs     - Lorenz attractor with X-Y scope.
%   lorenz2     - Lorenz attractor with storage scope.
%   tdeldemo    - Time delay and variable delay block.
%
% Other support routines.
%   rlsppd      - rlsest discrete pole-placement utility.
%   rlspps      - rlsest continuous pole-placement utility.
%   rlsests     - rlsest S-function utility.
%
% Data files for various models and demos.
%   ben2adat    - Constant definitions for ben2asys.
%   ben2bdat    - Constant definitions for ben2bsys.
%   ben2cdat    - Constant definitions for ben2csys.
%   ben3adat    - Constant definitions for ben3asys.
%   ben3bdat    - Constant definitions for ben3bsys.
%   multidat    - Data for multi demo.

% Copyright 1990-2002 The MathWorks, Inc.
% $Revision: 1.51 $
