function fig = aero_atcgui()
% AERO_ATCGUI Parameter input UI for conceptual design of ATC RADAR

%   Stacey Gage, 11/11/99
%   Copyright 1990-2004 The MathWorks, Inc.
%   $Revision: 1.4.2.2 $ $Date: 2004/04/15 00:38:59 $

% This is the machine-generated representation of a Handle Graphics object
% and its children.  Note that handle values may change when these objects
% are re-created. This may cause problems with any callbacks written to
% depend on the value of the handle at the time the object was saved.
% This problem is solved by saving the output as a FIG-file.
%
% To reopen this object, just type the name of the M-file at the MATLAB
% prompt. The M-file and its associated MAT-file must be on your path.
% 
% NOTE: certain newer features in MATLAB may not have been saved in this
% M-file due to limitations of this format, which has been superseded by
% FIG-files.  Figures which have been annotated using the plot editor tools
% are incompatible with the M-file/MAT-file format, and should be saved as
% FIG-files.

h0 = figure('Units','characters', ...
    'Color',[0 0 0], ...
    'Colormap',[jet(64)], ...
    'MenuBar','none', ...
    'Name','Air Traffic RADAR Design Parameters', ...
    'NumberTitle','off', ...
    'PaperPosition',[18 180 576 432], ...
    'PaperUnits','points', ...
    'Position',[2 19.5 85 37], ...
    'Resize','off', ...
    'Tag','Fig1', ...
    'ToolBar','none');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0 0.501960784313725 0.752941176470588], ...
    'Enable','off', ...
    'ListboxTop',0, ...
    'Position',[3.  1.5   45.0   34], ...
    'Style','frame', ...
    'Tag','Frame11');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[6.5   33.000   17.75    1.4], ...
    'String','RADAR Band', ...
    'Style','text', ...
    'Tag','RADAR_Band');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','Lambda=aero_atc_callback(''rband'');', ...
    'ListboxTop',0, ...
    'Max',0.3, ...
    'Min',0.15, ...
    'Position',[31   32.9   14    1.75], ...
    'String',['L Band';'S Band'], ...
    'Style','popupmenu', ...
    'Tag','RADAR_Band_select', ...
    'Value',1);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[16.25   30.2   20    1.25], ...
    'String','Wavelength (m)', ...
    'Style','text', ...
    'Tag','Wavelength');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','Lambda=aero_atc_callback(''wedit'');', ...
    'ListboxTop',0, ...
    'Max',0.3, ...
    'Min',0.15, ...
    'Position',[19.5   26.25    12.25    1.6], ...
    'String','0.285', ...
    'Style','edit', ...
    'Tag','Wavelength_edit', ...
    'Value',0.285);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'Callback','Lambda=aero_atc_callback(''wslider'');', ...
    'ListboxTop',0, ...
    'Max',0.3, ...
    'Min',0.15, ...
    'Position',[19.5   28.0   12.25    1.75], ...
    'Style','slider', ...
    'Tag','Wavelength_Slider', ...
    'Value',0.285);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[32.75   28.25    7.0    1.25], ...
    'String','0.3', ...
    'Style','text', ...
    'Tag','Wavelength_high');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[11.5   28.25    7.0    1.25], ...
    'String','0.15', ...
    'Style','text', ...
    'Tag','Wavelength_low');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[5.25   23.25   27.5    1.5], ...
    'String','Transmitter Power (kW)', ...
    'Style','text', ...
    'Tag','Trans_Power');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','Pt=aero_atc_callback(''pt'');', ...
    'ListboxTop',0, ...
    'Position',[36.5   23.25    8.6    1.5], ...
    'String','50', ...
    'Style','edit', ...
    'Tag','Trans_Power_edit', ...
    'Value',50);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[5.25   20.5   27.5    1.5], ...
    'String','Losses (dB)', ...
    'Style','text', ...
    'Tag','Losses');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','Losses=aero_atc_callback(''losses'');', ...
    'ListboxTop',0, ...
    'Position',[36.5   20.5    8.6    1.5], ...
    'String','5', ...
    'Style','edit', ...
    'Tag','Losses_edit', ...
    'Value',5);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[5.25   17.75   27.5    1.5], ...
    'String','Noise Factor (dB)', ...
    'Style','text', ...
    'Tag','Noise_Factor');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','Noise=aero_atc_callback(''noise'');', ...
    'ListboxTop',0, ...
    'Position',[36.5   17.75    8.6    1.5], ...
    'String','5', ...
    'Style','edit', ...
    'Tag','Noise_Factor_edit', ...
    'Value',5);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[5.25   15   27.5    1.5], ...
    'String','Antenna Efficiency', ...
    'Style','text', ...
    'Tag','Antenna_E');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','E=aero_atc_callback(''antennaE'');', ...
    'ListboxTop',0, ...
    'Position',[36.5   15.00    8.6    1.5], ...
    'String','0.7', ...
    'Style','edit', ...
    'Tag','Antenna_E_edit', ...
    'Value',0.7);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[5.25   11   29.5    1.5], ...
    'String','RADAR Range (N. Mile)', ...
    'Style','text', ...
    'Tag','RADAR_Range');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','Rrange=aero_atc_callback(''rrange'');', ...
    'ListboxTop',0, ...
    'Position',[36.5   11.   8.6    1.5], ...
    'String','50', ...
    'Style','edit', ...
    'Tag','RADAR_Range_edit', ...
    'Value',50);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[5.25    8.3   29.500    1.5], ...
    'String','Elev. Separation (N. Mile)', ...
    'Style','text', ...
    'Tag','EL_Sep');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','EL_Sep=aero_atc_callback(''elsep'');', ...
    'ListboxTop',0, ...
    'Position',[36.5    8.3    8.6    1.5], ...
    'String','2', ...
    'Style','edit', ...
    'Tag','EL_Sep_edit', ...
    'Value',2);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[5.25    5.5   29.500    1.5], ...
    'String','Lat. Separation (N. Mile)', ...
    'Style','text', ...
    'Tag','AZ_Sep');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','AZ_Sep=aero_atc_callback(''azsep'');', ...
    'ListboxTop',0, ...
    'Position',[36.5    5.5    8.6    1.5], ...
    'String','2', ...
    'Style','edit', ...
    'Tag','AZ_Sep_edit', ...
    'Value',2);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[5.25    2.6   29.500    1.5], ...
    'String','Range Resolution (m)', ...
    'Style','text', ...
    'Tag','Range_Res');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','Rres=aero_atc_callback(''rres'');', ...
    'ListboxTop',0, ...
    'Position',[36.5    2.6    8.6    1.5], ...
    'String','150', ...
    'Style','edit', ...
    'Tag','Range_Res_edit', ...
    'Value',150);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0 0.501960784313725 0.752941176470588], ...
    'ListboxTop',0, ...
    'Position',[49   12.5   33.5   23], ...
    'Style','frame', ...
    'Tag','Frame12');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[51.75   30.6073   27.5    2.3246], ...
    'String','Bandwidth (Hz) /Pulsewidth', ...
    'Style','text', ...
    'Tag','BW_PW');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','BwPw=aero_atc_callback(''bwpw'');', ...
    'ListboxTop',0, ...
    'Position',[61   28.5418    8.6    1.5], ...
    'String','1.2', ...
    'Style','edit', ...
    'Tag','BW_PW_edit', ...
    'Value',1.2);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[51.75   23.5   27.5    2.5], ...
    'String','Reliable Detection S/N (dB)', ...
    'Style','text', ...
    'Tag','SNR');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','SNR=aero_atc_callback(''snr'');', ...
    'ListboxTop',0, ...
    'Position',[61   21.5    8.6    1.5], ...
    'String','15', ...
    'Style','edit', ...
    'Tag','SNR_edit', ...
    'Value',15);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[51.75   15.75   27.5    2.5], ...
    'String','Working Temperature (deg F)', ...
    'Style','text', ...
    'Tag','Working_Temp');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[1 1 1], ...
    'Callback','Temp=aero_atc_callback(''temp'');', ...
    'ListboxTop',0, ...
    'Position',[61   13.75    8.6    1.5], ...
    'String','15', ...
    'Style','edit', ...
    'Tag','Working_Temp_edit', ...
    'Value',15);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0 0.501960784313725 0.752941176470588], ...
    'ListboxTop',0, ...
    'Position',[49    1.5   33.5   10.8], ...
    'Style','frame', ...
    'Tag','Frame22');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[53    10   23.5    1.5], ...
    'String','Weather Condition', ...
    'Style','text', ...
    'Tag','Precip_text');
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'Callback','rainfall=aero_atc_callback(''no precip'');', ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[51    8   29.7500    1.5], ...
    'String','No Precipitation', ...
    'Style','radiobutton', ...
    'Tag','No_precip', ...
    'UserData',0);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'Callback','rainfall=aero_atc_callback(''drizzle'');', ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[51    6.5   29.7500    1.5], ...
    'String','Drizzle', ...
    'Style','radiobutton', ...
    'Tag','Drizzle', ...
    'UserData',0.25);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'Callback','rainfall=aero_atc_callback(''light precip'');', ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[51    5.000   29.7500    1.5], ...
    'String','Light Precipitation', ...
    'Style','radiobutton', ...
    'Tag','Light_precip', ...
    'UserData',1, ...
    'Value',1);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'Callback','rainfall=aero_atc_callback(''moderate precip'');', ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[51    3.5  29.7500    1.5], ...
    'String','Moderate Precipitation', ...
    'Style','radiobutton', ...
    'Tag','Moderate_precip', ...
    'UserData',4);
h1 = uicontrol('Parent',h0, ...
    'Units','characters', ...
    'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
    'Callback','rainfall=aero_atc_callback(''heavy precip'');', ...
    'FontWeight','bold', ...
    'ListboxTop',0, ...
    'Position',[51    2.0   29.7500    1.5], ...
    'String','Heavy Precipitation', ...
    'Style','radiobutton', ...
    'Tag','Heavy_precip', ...
    'UserData',16);
if nargout > 0, fig = h0; end
