% Simulink: General model demonstrations and samples.
%
% Demonstration models (.mdl).
%   bangbang     - State event handling demonstration.
%   bounce       - Bouncing ball using reset integrator.
%   countersdemo - Counter demonstration.
%   dblcart1     - Double cart demoonstration.
%   dblpend1     - Double pendulum demonstration, version 1.
%   dblpend2     - Double pendulum demonstration, version 2.
%   hardstop     - Friction model with hard stops.
%   hydcyl       - Hydraulic cylinder model.
%   hydcyl4      - Four hydraulic cylinders.
%   hydrod       - Two hydraulic cylinders inteconnected with a stiff rod.
%   onecart      - Single cart/spring demonstration.
%   penddemo     - Inverted pendulum (on cart) with animation.
%   simppend     - Simple pendulum demonstration.
%   simquat      - Quaternion rotation with animation.
%   slprimes     - Simulink prime number calculator.
%   thermo       - Thermodynamics of a house.
%   toilet       - Toilet tank flushing animation.
%   vdp          - Van der Pol system of equations.
%
% Demonstration scripts.
%   vdpdemo    - Van der Pol equation.
%
% Execute the MATLAB command "demo simulink" to see a menu of most demos
% and models in this directory.  The demo menu is also available by
% opening the Demos block in the main Simulink block library (which is
% displayed by typing "simulink" at the MATLAB command line or by pressing
% the Simulink toolbar icon).
%
% Demos can also be run by typing their names at the MATLAB command line.
%
% Support routines and data files.
%   animinit.m      - Initialize animation for various demos.
%   crtanim1.m      - Animation for onecart.
%   crtanim2.m      - Animation for dblcart1.
%   dblcart1.mat    - Data for dblcart1.
%   dblpend1.mat    - Data for dblpend1.
%   dblpend2.mat    - Data for dblpend2.
%   eulrot.c        - S-Function for calculating Euler angles from rates for simquat.
%   eulrotdisplay.m - Display S-Function for simquat.
%   lights.mdl      - Simulink library with light block for slprimes.
%   newhcd.mat      - Data for hydcyl, hydcyl4, & hydrod.
%   pendan.m        - S-function for penddemo animation.
%   pndanim1.m      - Animation for simppend.
%   pndanim2.m      - Animation for dblpend1.
%   pndanim3.m      - Animation for dblpend2.
%   slight.m        - Light block S-function.
%   thermdat.m      - Front end script for thermo.
%   toilet.wav      - Sound for toilet animation.
%   toiletgui.m     - GUI for toilet animation.
%   toiletsfun.m    - S-function for toilet animation.
%   vdpdemo.m       - Front end script for vdp.
%

% Copyright 1990-2002 The MathWorks, Inc.
% $Revision: 1.7 $
