function mapOldMaskToCurrent = getMappingOldMaskToCurrent()
%getMappingOldMaskToCurrent  this is a private function that supports Simulink's slupdate

% Copyright 2004 The MathWorks, Inc.

mapOldMaskToCurrent = { ...
 'Algebraic Constraint', ...
                              'Algebraic Constraint', ...
                              'SubSystem', ...
                              'simulink/Math\nOperations/Algebraic Constraint'; ...
 'Band-Limited White Noise.', ...
                              'Band-Limited White Noise.', ...
                              'SubSystem', ...
                              'simulink/Sources/Band-Limited\nWhite Noise'; ...
 'Bit Clear', ...
                              'Bit Clear', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Bit Clear'; ...
 'Bit Set', ...
                              'Bit Set', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Bit Set'; ...
 'Bitwise Operator', ...
                              'Bitwise Operator', ...
                              'S-Function', ...
                              'simulink/Logic and Bit\nOperations/Bitwise\nOperator'; ...
 'BitwiseOperator', ...
                              'Bitwise Operator', ...
                              'S-Function', ...
                              'simulink/Logic and Bit\nOperations/Bitwise\nOperator'; ...
 'Block Support Table', ...
                              'Block Support Table', ...
                              'SubSystem', ...
                              'simulink/Model-Wide\nUtilities/Block Support\nTable'; ...
 'CMBlock', ...
                              'CMBlock', ...
                              'SubSystem', ...
                              'simulink/Model-Wide\nUtilities/Model Info'; ...
 'Compare To Constant', ...
                              'Compare To Constant', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Compare\nTo Constant'; ...
 'Compare To Zero', ...
                              'Compare To Zero', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Compare\nTo Zero'; ...
 'Continuous White Noise.', ...
                              'Band-Limited White Noise.', ...
                              'SubSystem', ...
                              'simulink/Sources/Band-Limited\nWhite Noise'; ...
 'Conversion Inherited', ...
                              'Conversion Inherited', ...
                              'SubSystem', ...
                              'simulink/Signal\nAttributes/Data Type\nConversion\nInherited'; ...
 'Cosine', ...
                              'Cosine', ...
                              'SubSystem', ...
                              'simulink/Lookup\nTables/Cosine'; ...
 'Coulombic and Viscous Friction', ...
                              'Coulombic and Viscous Friction', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Coulomb &\nViscous Friction'; ...
 'Counter Free-Running', ...
                              'Counter Free-Running', ...
                              'SubSystem', ...
                              'simulink/Sources/Counter\nFree-Running'; ...
 'Counter Limited', ...
                              'Counter Limited', ...
                              'SubSystem', ...
                              'simulink/Sources/Counter\nLimited'; ...
 'Data Type Duplicate', ...
                              'Data Type Duplicate', ...
                              'S-Function', ...
                              'simulink/Signal\nAttributes/Data Type\nDuplicate'; ...
 'Data Type Propagation', ...
                              'Data Type Propagation', ...
                              'S-Function', ...
                              'simulink/Signal\nAttributes/Data Type\nPropagation'; ...
 'Data Type Propagation Examples', ...
                              'Data Type Propagation Examples', ...
                              'SubSystem', ...
                              'simulink/Signal\nAttributes/Data Type\nPropagation Examples'; ...
 'Dead Zone Dynamic', ...
                              'Dead Zone Dynamic', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Dead Zone\nDynamic'; ...
 'Decrement Time To Zero', ...
                              'Decrement Time To Zero', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Decrement Time\nTo Zero'; ...
 'Decrement To Zero', ...
                              'Decrement To Zero', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Decrement\nTo Zero'; ...
 'Detect Change', ...
                              'Detect Change', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect\nChange'; ...
 'Detect Decrease', ...
                              'Detect Decrease', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect\nDecrease'; ...
 'Detect Fall Negative', ...
                              'Detect Fall Negative', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect Fall\nNegative'; ...
 'Detect Fall Nonpositive', ...
                              'Detect Fall Nonpositive', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect Fall\nNonpositive'; ...
 'Detect Increase', ...
                              'Detect Increase', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect\nIncrease'; ...
 'Detect Rise Nonnegative', ...
                              'Detect Rise Nonnegative', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect Rise\nNonnegative'; ...
 'Detect Rise Positive', ...
                              'Detect Rise Positive', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect Rise\nPositive'; ...
 'Difference', ...
                              'Difference', ...
                              'SubSystem', ...
                              'simulink/Discrete/Difference'; ...
 'Discrete Derivative', ...
                              'Discrete Derivative', ...
                              'SubSystem', ...
                              'simulink/Discrete/Discrete Derivative'; ...
 'DocBlock', ...
                              'DocBlock', ...
                              'SubSystem', ...
                              'simulink/Model-Wide\nUtilities/DocBlock'; ...
 'Dot Product', ...
                              'Dot Product', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Dot Product'; ...
 'Environment Controller', ...
                              'Environment Controller', ...
                              'SubSystem', ...
                              'simulink/Signal\nRouting/Environment\nController'; ...
 'Extract Bits', ...
                              'Extract Bits', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Extract Bits'; ...
 'First Order Transfer Fcn', ...
                              'First Order Transfer Fcn', ...
                              'SubSystem', ...
                              'simulink/Discrete/Transfer Fcn\nFirst Order'; ...
 'First-Order Hold', ...
                              'First-Order Hold', ...
                              'SubSystem', ...
                              'simulink/Discrete/First-Order\nHold'; ...
 'Fixed-Point Absolute Value', ...
                              '', ...
                              'Abs', ...
                              'built-in/Abs'; ...
 'Fixed-Point Accumulator', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Accumulator Resettable', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Accumulator Resettable Limited', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Bit Clear', ...
                              'Bit Clear', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Bit Clear'; ...
 'Fixed-Point Bit Set', ...
                              'Bit Set', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Bit Set'; ...
 'Fixed-Point Bitwise Operator', ...
                              'Bitwise Operator', ...
                              'S-Function', ...
                              'simulink/Logic and Bit\nOperations/Bitwise\nOperator'; ...
 'Fixed-Point Compare To Constant', ...
                              'Compare To Constant', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Compare\nTo Constant'; ...
 'Fixed-Point Compare To Zero', ...
                              'Compare To Zero', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Compare\nTo Zero'; ...
 'Fixed-Point Constant', ...
                              '', ...
                              'Constant', ...
                              'built-in/Constant'; ...
 'Fixed-Point Cosine', ...
                              'Cosine', ...
                              'SubSystem', ...
                              'simulink/Lookup\nTables/Cosine'; ...
 'Fixed-Point Counter Free', ...
                              'Counter Free-Running', ...
                              'SubSystem', ...
                              'simulink/Sources/Counter\nFree-Running'; ...
 'Fixed-Point Counter Limited', ...
                              'Counter Limited', ...
                              'SubSystem', ...
                              'simulink/Sources/Counter\nLimited'; ...
 'Fixed-Point Data Type Duplicate', ...
                              'Data Type Duplicate', ...
                              'S-Function', ...
                              'simulink/Signal\nAttributes/Data Type\nDuplicate'; ...
 'Fixed-Point Data Type Propagation', ...
                              'Data Type Propagation', ...
                              'S-Function', ...
                              'simulink/Signal\nAttributes/Data Type\nPropagation'; ...
 'Fixed-Point Dead Zone', ...
                              '', ...
                              'DeadZone', ...
                              'built-in/DeadZone'; ...
 'Fixed-Point Dead Zone Dynamic', ...
                              'Dead Zone Dynamic', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Dead Zone\nDynamic'; ...
 'Fixed-Point Decrement Time To Zero', ...
                              'Decrement Time To Zero', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Decrement Time\nTo Zero'; ...
 'Fixed-Point Decrement To Zero', ...
                              'Decrement To Zero', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Decrement\nTo Zero'; ...
 'Fixed-Point Derivative', ...
                              'Discrete Derivative', ...
                              'SubSystem', ...
                              'simulink/Discrete/Discrete Derivative'; ...
 'Fixed-Point Detect Change', ...
                              'Detect Change', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect\nChange'; ...
 'Fixed-Point Detect Decrease', ...
                              'Detect Decrease', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect\nDecrease'; ...
 'Fixed-Point Detect Fall Negative', ...
                              'Detect Fall Negative', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect Fall\nNegative'; ...
 'Fixed-Point Detect Fall Nonpositive', ...
                              'Detect Fall Nonpositive', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect Fall\nNonpositive'; ...
 'Fixed-Point Detect Increase', ...
                              'Detect Increase', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect\nIncrease'; ...
 'Fixed-Point Detect Rise Nonnegative', ...
                              'Detect Rise Nonnegative', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect Rise\nNonnegative'; ...
 'Fixed-Point Detect Rise Positive', ...
                              'Detect Rise Positive', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Detect Rise\nPositive'; ...
 'Fixed-Point Difference', ...
                              'Difference', ...
                              'SubSystem', ...
                              'simulink/Discrete/Difference'; ...
 'Fixed-Point Dot Product', ...
                              'Dot Product', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Dot Product'; ...
 'Fixed-Point FIR', ...
                              'Weighted Moving Average', ...
                              'S-Function', ...
                              'simulink/Discrete/Weighted\nMoving Average'; ...
 'Fixed-Point Filter Direct Form I', ...
                              'Transfer Fcn Direct Form I', ...
                              'SubSystem', ...
                              'fixpt_lib_4/Filters/Filter\nDirect Form I'; ...
 'Fixed-Point Filter Direct Form I Time Varying', ...
                              'Transfer Fcn Direct Form I Time Varying', ...
                              'SubSystem', ...
                              'fixpt_lib_4/Filters/Filter\nDirect Form I\nTime Varying'; ...
 'Fixed-Point Filter Direct Form II', ...
                              'Transfer Fcn Direct Form II', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Transfer Fcn\nDirect Form II'; ...
 'Fixed-Point Filter Direct Form II Time Varying', ...
                              'Transfer Fcn Direct Form II Time Varying', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Transfer Fcn\nDirect Form II\nTime Varying'; ...
 'Fixed-Point Filter First Order', ...
                              'First Order Transfer Fcn', ...
                              'SubSystem', ...
                              'simulink/Discrete/Transfer Fcn\nFirst Order'; ...
 'Fixed-Point Filter Lead or Lag', ...
                              'Lead or Lag Compensator', ...
                              'SubSystem', ...
                              'simulink/Discrete/Transfer Fcn\nLead or Lag'; ...
 'Fixed-Point Filter Real Zero', ...
                              'Transfer Fcn Real Zero', ...
                              'SubSystem', ...
                              'simulink/Discrete/Transfer Fcn\nReal Zero'; ...
 'Fixed-Point GUI', ...
                              'Fixed-Point GUI', ...
                              'SubSystem', ...
                              'fixpt_lib_4/FixPt\nGUI'; ...
 'Fixed-Point Gain', ...
                              '', ...
                              'Gain', ...
                              'built-in/Gain'; ...
 'Fixed-Point Gateway In', ...
                              '', ...
                              'DataTypeConversion', ...
                              'built-in/DataTypeConversion'; ...
 'Fixed-Point Gateway In Inherited', ...
                              'Conversion Inherited', ...
                              'SubSystem', ...
                              'simulink/Signal\nAttributes/Data Type\nConversion\nInherited'; ...
 'Fixed-Point Gateway Out', ...
                              '', ...
                              'DataTypeConversion', ...
                              'built-in/DataTypeConversion'; ...
 'Fixed-Point Integer Delay', ...
                              'Integer Delay', ...
                              'S-Function', ...
                              'simulink/Discrete/Integer Delay'; ...
 'Fixed-Point Integrator Backward', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Integrator Backward Resettable', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Integrator Backward Resettable Limited', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Integrator Forward', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Integrator Forward Resettable', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Integrator Forward Resettable Limited', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Integrator Trapezoidal', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Integrator Trapezoidal Resettable', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Integrator Trapezoidal Resettable Limited', ...
                              '', ...
                              'DiscreteIntegrator', ...
                              'built-in/DiscreteIntegrator'; ...
 'Fixed-Point Interval Test', ...
                              'Interval Test', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Interval Test'; ...
 'Fixed-Point Interval Test Dynamic', ...
                              'Interval Test Dynamic', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Interval Test\nDynamic'; ...
 'Fixed-Point Logical Operator', ...
                              '', ...
                              'Logic', ...
                              'built-in/Logic'; ...
 'Fixed-Point Look-Up Table', ...
                              '', ...
                              'Lookup', ...
                              'built-in/Lookup'; ...
 'Fixed-Point Look-Up Table (2-D)', ...
                              '', ...
                              'Lookup2D', ...
                              'built-in/Lookup2D'; ...
 'Fixed-Point Look-Up Table Dynamic', ...
                              'Lookup Table Dynamic', ...
                              'S-Function', ...
                              'simulink/Lookup\nTables/Lookup\nTable\nDynamic'; ...
 'Fixed-Point Matrix Gain', ...
                              '', ...
                              'Gain', ...
                              'built-in/Gain'; ...
 'Fixed-Point MinMax', ...
                              '', ...
                              'MinMax', ...
                              'built-in/MinMax'; ...
 'Fixed-Point MinMax Running Resettable', ...
                              'MinMax Running Resettable', ...
                              'SubSystem', ...
                              'simulink/Math\nOperations/MinMax\nRunning\nResettable'; ...
 'Fixed-Point Multi Port Switch', ...
                              '', ...
                              'MultiPortSwitch', ...
                              'built-in/MultiPortSwitch'; ...
 'Fixed-Point Product', ...
                              '', ...
                              'Product', ...
                              'built-in/Product'; ...
 'Fixed-Point Rate Limiter', ...
                              '', ...
                              'RateLimiter', ...
                              'built-in/RateLimiter'; ...
 'Fixed-Point Rate Limiter Dynamic', ...
                              'Rate Limiter Dynamic', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Rate Limiter\nDynamic'; ...
 'Fixed-Point Real World Value Decrement', ...
                              'Real World Value Decrement', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Decrement\nReal World'; ...
 'Fixed-Point Real World Value Increment', ...
                              'Real World Value Increment', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Increment\nReal World'; ...
 'Fixed-Point Relational Operator', ...
                              '', ...
                              'RelationalOperator', ...
                              'built-in/RelationalOperator'; ...
 'Fixed-Point Relay', ...
                              '', ...
                              'Relay', ...
                              'built-in/Relay'; ...
 'Fixed-Point Repeating Sequence Interpolated', ...
                              'Repeating Sequence Interpolated', ...
                              'SubSystem', ...
                              'simulink/Sources/Repeating\nSequence\nInterpolated'; ...
 'Fixed-Point Repeating Sequence Stair', ...
                              'Repeating Sequence Stair', ...
                              'SubSystem', ...
                              'simulink/Sources/Repeating\nSequence\nStair'; ...
 'Fixed-Point Sample Time Math', ...
                              'Sample Time Math', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Weighted\nSample Time\nMath'; ...
 'Fixed-Point Saturation', ...
                              '', ...
                              'Saturate', ...
                              'built-in/Saturate'; ...
 'Fixed-Point Saturation Dynamic', ...
                              'Saturation Dynamic', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Saturation\nDynamic'; ...
 'Fixed-Point Scaling Strip', ...
                              'Scaling Strip', ...
                              'SubSystem', ...
                              'simulink/Signal\nAttributes/Data Type\nScaling Strip'; ...
 'Fixed-Point Shift Arithmetic', ...
                              'Shift Arithmetic', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Shift\nArithmetic'; ...
 'Fixed-Point Signum', ...
                              '', ...
                              'Signum', ...
                              'built-in/Signum'; ...
 'Fixed-Point Sine', ...
                              'Sine', ...
                              'SubSystem', ...
                              'simulink/Lookup\nTables/Sine'; ...
 'Fixed-Point State Enabled', ...
                              'Unit Delay With Preview Enabled', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nEnabled'; ...
 'Fixed-Point State Enabled Resettable', ...
                              'Unit Delay With Preview Enabled Resettable', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nEnabled\nResettable'; ...
 'Fixed-Point State Resettable', ...
                              'Unit Delay With Preview Resettable', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nResettable'; ...
 'Fixed-Point State-Space', ...
                              'Fixed-Point State-Space', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Fixed-Point\nState-Space'; ...
 'Fixed-Point Stored Integer Value Decrement', ...
                              'Stored Integer Value Decrement', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Decrement\nStored Integer'; ...
 'Fixed-Point Stored Integer Value Increment', ...
                              'Stored Integer Value Increment', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Increment\nStored Integer'; ...
 'Fixed-Point Sum', ...
                              '', ...
                              'Sum', ...
                              'built-in/Sum'; ...
 'Fixed-Point Switch', ...
                              '', ...
                              'Switch', ...
                              'built-in/Switch'; ...
 'Fixed-Point Tapped Delay Line', ...
                              'Tapped Delay Line', ...
                              'S-Function', ...
                              'simulink/Discrete/Tapped Delay'; ...
 'Fixed-Point Unary Minus', ...
                              'Unary Minus', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Unary Minus'; ...
 'Fixed-Point Unit Delay', ...
                              '', ...
                              'UnitDelay', ...
                              'built-in/UnitDelay'; ...
 'Fixed-Point Unit Delay Enabled', ...
                              'Unit Delay Enabled', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nEnabled'; ...
 'Fixed-Point Unit Delay Enabled External Initial Condition', ...
                              'Unit Delay Enabled External Initial Condition', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nEnabled\nExternal IC'; ...
 'Fixed-Point Unit Delay Enabled Resettable', ...
                              'Unit Delay Enabled Resettable', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nEnabled\nResettable'; ...
 'Fixed-Point Unit Delay Enabled Resettable External Initial Condition', ...
                              'Unit Delay Enabled Resettable External Initial Condition', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nEnabled\nResettable\nExternal IC'; ...
 'Fixed-Point Unit Delay External Initial Condition', ...
                              'Unit Delay External Initial Condition', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nExternal IC'; ...
 'Fixed-Point Unit Delay Resettable', ...
                              'Unit Delay Resettable', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nResettable'; ...
 'Fixed-Point Unit Delay Resettable External Initial Condition', ...
                              'Unit Delay Resettable External Initial Condition', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nResettable\nExternal IC'; ...
 'Fixed-Point Unit Delay With Preview Enabled Resettable External RV', ...
                              'Unit Delay With Preview Enabled Resettable External RV', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nEnabled\nResettable\nExternal RV'; ...
 'Fixed-Point Unit Delay With Preview Resettable External RV', ...
                              'Unit Delay With Preview Resettable External RV', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nResettable\nExternal RV'; ...
 'Fixed-Point Wrap To Zero', ...
                              'Wrap To Zero', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Wrap To Zero'; ...
 'Fixed-Point Zero-Order Hold', ...
                              '', ...
                              'ZeroOrderHold', ...
                              'built-in/ZeroOrderHold'; ...
 'Fixed-Point to Fixed-Point Conversion', ...
                              '', ...
                              'DataTypeConversion', ...
                              'built-in/DataTypeConversion'; ...
 'Fixed-Point to Fixed-Point Inherited Conversion', ...
                              'Conversion Inherited', ...
                              'SubSystem', ...
                              'simulink/Signal\nAttributes/Data Type\nConversion\nInherited'; ...
 'Fixed-Point-Private Quandrant Processing Sine', ...
                              '', ...
                              'Reference', ...
                              'built-in/Reference'; ...
 'Fixed-Point-Private Quandrant Processing Sine', ...
                              'Fixed-Point-Private Quandrant Processing Sine', ...
                              'SubSystem', ...
                              'simulink/Lookup\nTables/Cosine/Handle Quarter Symetery Cosine'; ...
 'Function-Call Generator', ...
                              'Function-Call Generator', ...
                              'S-Function', ...
                              'simulink/Ports &\nSubsystems/Function-Call\nGenerator'; ...
 'Integer Delay', ...
                              'Integer Delay', ...
                              'S-Function', ...
                              'simulink/Discrete/Integer Delay'; ...
 'Interval Test', ...
                              'Interval Test', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Interval Test'; ...
 'Interval Test Dynamic', ...
                              'Interval Test Dynamic', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Interval Test\nDynamic'; ...
 'Lead or Lag Compensator', ...
                              'Lead or Lag Compensator', ...
                              'SubSystem', ...
                              'simulink/Discrete/Transfer Fcn\nLead or Lag'; ...
 'Lookup Table (2-D)', ...
                              '', ...
                              'Lookup2D', ...
                              'built-in/Lookup2D'; ...
 'Lookup Table Dynamic', ...
                              'Lookup Table Dynamic', ...
                              'S-Function', ...
                              'simulink/Lookup\nTables/Lookup\nTable\nDynamic'; ...
 'LookupIdxSearch', ...
                              'LookupIdxSearch', ...
                              'S-Function', ...
                              'simulink/Lookup\nTables/PreLookup\nIndex Search'; ...
 'LookupNDDirect', ...
                              'LookupNDDirect', ...
                              'S-Function', ...
                              'simulink/Lookup\nTables/Direct Lookup\nTable (n-D)'; ...
 'LookupNDInterp', ...
                              'LookupNDInterp', ...
                              'S-Function', ...
                              'simulink/Lookup\nTables/Lookup\nTable (n-D)'; ...
 'LookupNDInterpIdx', ...
                              'LookupNDInterpIdx', ...
                              'S-Function', ...
                              'simulink/Lookup\nTables/Interpolation (n-D)\nusing PreLookup'; ...
 'Manual Switch', ...
                              'Manual Switch', ...
                              'SubSystem', ...
                              'simulink/Signal\nRouting/Manual Switch'; ...
 'Matrix Concatenation', ...
                              'Matrix Concatenation', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Matrix\nConcatenation'; ...
 'Matrix Gain', ...
                              '', ...
                              'Gain', ...
                              'built-in/Gain'; ...
 'MinMax Running Resettable', ...
                              'MinMax Running Resettable', ...
                              'SubSystem', ...
                              'simulink/Math\nOperations/MinMax\nRunning\nResettable'; ...
 'Model Advisor', ...
                              'Model Advisor', ...
                              'SubSystem', ...
                              'simulink/Model-Wide\nUtilities/Model Advisor'; ...
 'Polyval', ...
                              'Polyval', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Polynomial'; ...
 'Pulse Generator', ...
                              '', ...
                              'DiscretePulseGenerator', ...
                              'built-in/DiscretePulseGenerator'; ...
 'Ramp', ...
                              'Ramp', ...
                              'SubSystem', ...
                              'simulink/Sources/Ramp'; ...
 'Rate Limiter Dynamic', ...
                              'Rate Limiter Dynamic', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Rate Limiter\nDynamic'; ...
 'Rate_Transition', ...
                              '', ...
                              'RateTransition', ...
                              'built-in/RateTransition'; ...
 'Real World Value Decrement', ...
                              'Real World Value Decrement', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Decrement\nReal World'; ...
 'Real World Value Increment', ...
                              'Real World Value Increment', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Increment\nReal World'; ...
 'Repeating Sequence Interpolated', ...
                              'Repeating Sequence Interpolated', ...
                              'SubSystem', ...
                              'simulink/Sources/Repeating\nSequence\nInterpolated'; ...
 'Repeating Sequence Stair', ...
                              'Repeating Sequence Stair', ...
                              'SubSystem', ...
                              'simulink/Sources/Repeating\nSequence\nStair'; ...
 'Repeating table', ...
                              'Repeating table', ...
                              'SubSystem', ...
                              'simulink/Sources/Repeating\nSequence'; ...
 'Reshape', ...
                              'Reshape', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Reshape'; ...
 'S-Function Examples', ...
                              'S-Function Examples', ...
                              'SubSystem', ...
                              'simulink/User-Defined\nFunctions/S-Function Examples'; ...
 'Sample Time Math', ...
                              'Sample Time Math', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Weighted\nSample Time\nMath'; ...
 'Saturation Dynamic', ...
                              'Saturation Dynamic', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Saturation\nDynamic'; ...
 'Scaling Strip', ...
                              'Scaling Strip', ...
                              'SubSystem', ...
                              'simulink/Signal\nAttributes/Data Type\nScaling Strip'; ...
 'Shift Arithmetic', ...
                              'Shift Arithmetic', ...
                              'SubSystem', ...
                              'simulink/Logic and Bit\nOperations/Shift\nArithmetic'; ...
 'Signal Specification', ...
                              '', ...
                              'SignalSpecification', ...
                              'built-in/SignalSpecification'; ...
 'Sine', ...
                              'Sine', ...
                              'SubSystem', ...
                              'simulink/Lookup\nTables/Sine'; ...
 'Slider Gain', ...
                              'Slider Gain', ...
                              'SubSystem', ...
                              'simulink/Math\nOperations/Slider\nGain'; ...
 'Stored Integer Value Decrement', ...
                              'Stored Integer Value Decrement', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Decrement\nStored Integer'; ...
 'Stored Integer Value Increment', ...
                              'Stored Integer Value Increment', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional Math:\nIncrement - Decrement/Increment\nStored Integer'; ...
 'Subsystem Examples', ...
                              'Subsystem Examples', ...
                              'SubSystem', ...
                              'simulink/Ports &\nSubsystems/Subsystem Examples'; ...
 'Tapped Delay Line', ...
                              'Tapped Delay Line', ...
                              'S-Function', ...
                              'simulink/Discrete/Tapped Delay'; ...
 'Timed Linearization', ...
                              'Timed Linearization', ...
                              'SubSystem', ...
                              'simulink/Model-Wide\nUtilities/Timed-Based\nLinearization'; ...
 'Transfer Fcn Direct Form II', ...
                              'Transfer Fcn Direct Form II', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Transfer Fcn\nDirect Form II'; ...
 'Transfer Fcn Direct Form II Time Varying', ...
                              'Transfer Fcn Direct Form II Time Varying', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Transfer Fcn\nDirect Form II\nTime Varying'; ...
 'Transfer Fcn Real Zero', ...
                              'Transfer Fcn Real Zero', ...
                              'SubSystem', ...
                              'simulink/Discrete/Transfer Fcn\nReal Zero'; ...
 'Triggered Linearization', ...
                              'Triggered Linearization', ...
                              'SubSystem', ...
                              'simulink/Model-Wide\nUtilities/Trigger-Based\nLinearization'; ...
 'Unary Minus', ...
                              'Unary Minus', ...
                              'S-Function', ...
                              'simulink/Math\nOperations/Unary Minus'; ...
 'Unit Delay Enabled', ...
                              'Unit Delay Enabled', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nEnabled'; ...
 'Unit Delay Enabled External Initial Condition', ...
                              'Unit Delay Enabled External Initial Condition', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nEnabled\nExternal IC'; ...
 'Unit Delay Enabled Resettable', ...
                              'Unit Delay Enabled Resettable', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nEnabled\nResettable'; ...
 'Unit Delay Enabled Resettable External Initial Condition', ...
                              'Unit Delay Enabled Resettable External Initial Condition', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nEnabled\nResettable\nExternal IC'; ...
 'Unit Delay External Initial Condition', ...
                              'Unit Delay External Initial Condition', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nExternal IC'; ...
 'Unit Delay Resettable', ...
                              'Unit Delay Resettable', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nResettable'; ...
 'Unit Delay Resettable External Initial Condition', ...
                              'Unit Delay Resettable External Initial Condition', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nResettable\nExternal IC'; ...
 'Unit Delay With Preview Enabled', ...
                              'Unit Delay With Preview Enabled', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nEnabled'; ...
 'Unit Delay With Preview Enabled Resettable', ...
                              'Unit Delay With Preview Enabled Resettable', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nEnabled\nResettable'; ...
 'Unit Delay With Preview Enabled Resettable External RV', ...
                              'Unit Delay With Preview Enabled Resettable External RV', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nEnabled\nResettable\nExternal RV'; ...
 'Unit Delay With Preview Resettable', ...
                              'Unit Delay With Preview Resettable', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nResettable'; ...
 'Unit Delay With Preview Resettable External RV', ...
                              'Unit Delay With Preview Resettable External RV', ...
                              'SubSystem', ...
                              'simulink/Additional Math\n& Discrete/Additional\nDiscrete/Unit Delay\nWith Preview\nResettable\nExternal RV'; ...
 'Weighted Moving Average', ...
                              'Weighted Moving Average', ...
                              'S-Function', ...
                              'simulink/Discrete/Weighted\nMoving Average'; ...
 'Wrap To Zero', ...
                              'Wrap To Zero', ...
                              'SubSystem', ...
                              'simulink/Discontinuities/Wrap To Zero'; ...
 'XY scope.', ...
                              'XY scope.', ...
                              'SubSystem', ...
                              'simulink/Sinks/XY Graph'; ...
 'chirp', ...
                              'chirp', ...
                              'SubSystem', ...
                              'simulink/Sources/Chirp Signal' ...
};
mapOldMaskToCurrent = cell2struct(mapOldMaskToCurrent, { 'oldMaskType','newMaskType','newBlockType','newRefBlock' }, 2);