function simmenu(action)
%SIMMENU Simulation Menu callbacks for SIMMENU.
%   Derived from HGMENU for Simulation Parameter Dialog Box and Mask Editor.

%   Copyright 1990-2002 The MathWorks, Inc.
%   $Revision: 1.11 $
%   Sanjai Singh, May 13, 1996.

if nargin==0, 
    % Clean out the CreateFcn, then put up the menus only on workstations
    figNumber=get(0,'CurrentFigure');
    set(figNumber,'CreateFcn','');
    if strcmp(get(figNumber,'MenuBar'),'none')
      if strncmp(computer,'MA',2)
        action='initialize';
      else
        action='';
      end
    else
      error(['Simmenu is to be used only when the menubar property '...
             'is set to "none".'])
      action = '';
    end
end

switch action
  case 'initialize'
    figNumber=gcf;

    fileHndl=uimenu(figNumber, ...
                   'Label','File', ...
                   'Tag'  ,'MenuFile', ...                   
                   'HandleVisibility','callback');
    newHndl=uimenu(fileHndl, ...
                  'Label','New', ...
                  'Tag'  ,'MenuFileNew', ...                  
                  'HandleVisibility','callback');
            uimenu(newHndl, ...
                  'Label','M-File', ...
                  'Tag','MenuFileNewM-File', ...
                  'HandleVisibility','callback', ...
                  'Enable','off', ...
                  'Callback','simmenu newmfile');
            uimenu(newHndl, ...
                  'Label','Figure', ...
                  'Tag','MenuFileNewFigure', ...
                  'HandleVisibility','callback', ...
                  'Callback','figure');
                % Check for the presence of SIMULINK
       if ~exist('open_system','builtin'), enableStr='off'; else enableStr='on'; end
        uimenu(newHndl, ...
            'Label','Model', ...
            'Tag','MenuFileNewModel', ...
            'HandleVisibility','callback', ...
            'Accelerator','n', ...
            'Enable',enableStr, ...
            'Callback','simmenu newmodel');
         uimenu(fileHndl, ...
            'Label','Open', ...
            'Tag','MenuFileOpen', ...
            'HandleVisibility','callback', ...
            'Accelerator','o', ...
            'Enable','off', ...
            'Callback','simmenu open'); %uiopen
        uimenu(fileHndl, ...
            'Label','Close', ...
            'Tag','MenuFileClose', ...
            'HandleVisibility','callback', ...
            'Accelerator','w', ...
            'Callback','close(gcf)');
        uimenu(fileHndl, ...
            'Label','Save', ...
           'Tag','MenuFileSave', ...
            'HandleVisibility','callback', ...
            'Enable','off', ...
            'Accelerator','s', ...
            'Callback',''); %uisave
        uimenu(fileHndl, ...
            'Label','Save As...', ...
            'Tag','MenuFileSave As...', ...
            'HandleVisibility','callback', ...
            'Enable','off', ...
            'Callback',''); %uisaveas
    uimenu(fileHndl, ...
           'Label','Printer Setup...', ...
           'Tag','MenuFilePrinter Setup...', ...
           'HandleVisibility','callback', ...
           'Enable','off', ...
           'Callback','');
    uimenu(fileHndl, ...
           'Label','Print...', ...
           'Tag','MenuFilePrint...', ...
           'HandleVisibility','callback', ...
           'Enable','off', ...
           'Accelerator','p', ...
           'Callback','');
    uimenu(fileHndl, ...
          'Label','Quit', ...
          'Tag','MenuFileQuit', ...
          'HandleVisibility','callback', ...
          'Callback','quit');



    editHndl=uimenu(figNumber, ...
                   'Label','Edit', ...
                   'Tag','MenuEdit', ...
                   'HandleVisibility','callback');
    uimenu(editHndl, ...
        'Label','Undo', ...
        'Tag','MenuEditUndo', ...
        'HandleVisibility','callback', ...
        'Enable','off', ...
        'Accelerator','z', ...
        'Callback','%uiundo');
    uimenu(editHndl, ...
        'Label','Cut', ...
        'Tag','MenuEditCut', ...
        'HandleVisibility','callback', ...
        'Enable','off', ...
        'Accelerator','x', ...
        'Callback','%uicut');
    uimenu(editHndl, ...
        'Label','Copy', ...
        'Tag','MenuEditCopy', ...
        'HandleVisibility','callback', ...
        'Enable','off', ...
        'Accelerator','c', ...
        'Callback','%uicopy');
    uimenu(editHndl, ...
        'Label','Paste', ...
        'Tag','MenuEditPaste', ...
        'HandleVisibility','callback', ...
        'Enable','off', ...
        'Accelerator','v', ...
        'Callback','%uipaste');
    uimenu(editHndl, ...
        'Label','Clear', ...
        'Tag','MenuEditClear', ...
        'HandleVisibility','callback', ...
        'Enable','off', ...
        'Callback','%uiclear');
    uimenu(editHndl, ...
        'Label','Select All', ...
        'Tag','MenuEditSelect All', ...
        'HandleVisibility','callback', ...
        'Enable','off', ...
        'Callback','%uiselectall');

  case 'newmfile'

  case 'newmodel'
    new_system('untitled');
    open_system('untitled');

  case 'open'
    % getpref code has been temporarily removed.
    % Remove this capability until futher notice...
    % editStr=getpref('matlab','editor','xterm -e vi');
    %[statusFlag,editStr]=unix('printenv EDITOR');
    % Replace all newlines with spaces
    %editStr=strrep(editStr,setstr(10),setstr(32));
    % I still don't have a good way to tell if it's a file or a figure.
    %if ~statusFlag, 
    %    [fileName,pathName]=uigetfile('*','Open);
    %    % fileName is 0 if Cancel has been hit...
    %    if isstr(fileName),
    %        evalStr=['!' editStr ' ' pathName fileName ' &']
    %        eval(evalStr);
    %    end
    %else
    %    warndlg('Cannot find environment variable EDITOR');
    %end

end
