function simParamMap = simprmfield2prmmap
%SIMPARAM2TARGETPROPMAP  Define the mapping from a model's
%   simulation parameters to target object properties.

%   Copyright 2002 The MathWorks, Inc.
%   $Revision: 1.1.6.1 $  $Date: 2002/09/23 16:29:55 $

simParamMap = {
    'SimulationMode'                   'SimTarget',        '',        '*'
    ... Solver
    'StartTime',                       'All',        'Solver',            '*'
    'StopTime',                        'All',        'Solver',            '*'
    'Solver',                          'All',        'Solver',            '*'
    'SolverMode',                      'All',        'Solver',            '*'
    'RelTol',                          'All',        'Solver',            '*'
    'AbsTol',                          'All',        'Solver',            '*'
    'FixedStep',                       'All',        'Solver',            '*'
    'MaxStep',                         'All',        'Solver',            '*'
    'InitialStep',                     'All',        'Solver',            '*'
    'MinStep',                         'All',        'Solver',            '*'
    'MaxNumMinSteps',                  'All',        'Solver',            '*' % hidden
    'MaxOrder',                        'All',        'Solver',            '*' % hidden
    'OutputOption',                    'All',        'Solver',            '*'
    'OutputTimes',                     'All',        'Solver',            '*'
    'Refine',                          'All',        'Solver',            '*'
    ... Workspace IO
    'LoadExternalInput',               'All',        'Workspace I/O',       '*'
    'ExternalInput',                   'All',        'Workspace I/O',       '*'
    'LoadInitialState',                'All',        'Workspace I/O',       '*'
    'InitialState',                    'All',        'Workspace I/O',       '*'
    'SaveTime',                        'All',        'Workspace I/O',       '*'
    'TimeSaveName',                    'All',        'Workspace I/O',       '*'
    'SaveState',                       'All',        'Workspace I/O',       '*'
    'StateSaveName',                   'All',        'Workspace I/O',       '*'
    'SaveOutput',                      'All',        'Workspace I/O',       '*'
    'OutputSaveName',                  'All',        'Workspace I/O',       '*'
    'SaveFinalState',                  'All',        'Workspace I/O',       '*'
    'FinalStateName',                  'All',        'Workspace I/O',       '*'
    'SaveFormat',                      'All',        'Workspace I/O',       '*'
    'LimitDataPoints',                 'All',        'Workspace I/O',       '*'
    'MaxDataPoints',                   'All',        'Workspace I/O',       '*'
    'Decimation',                      'All',        'Workspace I/O',       '*'
    ... Diagnostics                                                                   
    'ConsistencyChecking',             'All',        'Diagnostics',       '*'
    'ArrayBoundsChecking',             'All',        'Diagnostics',       '*'
    'AlgebraicLoopMsg',                'All',        'Diagnostics',       '*'
    'BlockPriorityViolationMsg',       'All',        'Diagnostics',       '*'
    'MinStepSizeMsg',                  'All',        'Diagnostics',       '*'
    'InheritedTsInSrcMsg',             'All',        'Diagnostics',       '*'
    'DiscreteInheritContinuousMsg',    'All',        'Diagnostics',       '*'
    'MultiTaskRateTransMsg',           'All',        'Diagnostics',       '*'
    'SingleTaskRateTransMsg',          'All',        'Diagnostics',       '*'
    'CheckForMatrixSingularity',       'All',        'Diagnostics',       '*'
    'IntegerOverflowMsg',              'All',        'Diagnostics',       '*'
    'Int32ToFloatConvMsg',             'All',        'Diagnostics',       '*'
    'ParameterDowncastMsg',            'All',        'Diagnostics',       '*'
    'ParameterOverflowMsg',            'All',        'Diagnostics',       '*'
    'ParameterPrecisionLossMsg',       'All',        'Diagnostics',       '*'
    'UnderSpecifiedDataTypeMsg',       'All',        'Diagnostics',       '*'
    'UnnecessaryDatatypeConvMsg',      'All',        'Diagnostics',       '*'
    'VectorMatrixConversionMsg',       'All',        'Diagnostics',       '*'
    'InvalidFcnCallConnMsg',           'All',        'Diagnostics',       '*'
    'SignalLabelMismatchMsg',          'All',        'Diagnostics',       '*'
    'UnconnectedInputMsg',             'All',        'Diagnostics',       '*'
    'UnconnectedOutputMsg',            'All',        'Diagnostics',       '*'
    'UnconnectedLineMsg',              'All',        'Diagnostics',       '*'
    'SfunCompatibilityCheckMsg',       'All',        'Diagnostics',       '*'
    ... Advanced                                                                  
    'RTWInlineParameters',             'All',        'Advanced',          'InlineParameters'
    'TunableVars',                     'All',        'Advanced',          '*' % hidden
    'TunableVarsStorageClass',         'All',        'Advanced',          '*' % hidden
    'TunableVarsTypeQualifier',        'All',        'Advanced',          '*' % hidden
    'ParamWorkspaceSource',            'All',        'Advanced',          '*' % hidden
    'BlockReductionOpt',               'All',        'Advanced',          'BlockReduction'
    'BooleanDataType',                 'All',        'Advanced',          '*'
    'ConditionallyExecuteInputs',      'All',        'Advanced',          '*'
    'ParameterPooling',                'All',        'Advanced',          '*'
    'OptimizeBlockIOStorage',          'All',        'Advanced',          'SignalStorageReuse'
    'ZeroCross',                       'All',        'Advanced',          'ZeroCrossing'
    'AssertionControl',                'All',        'Advanced',          '*'
    ... External Mode (don't need to implement immediately)
    'ExtModeMexFile',                  'All',        'External Mode',      '*'
    'ExtModeMexArgs',                  'All',        'External Mode',      '*'
    'ExtModeBatchMode',                'All',        'External Mode',      '*'
    'ExtModeChangesPending',           'All',        'External Mode',      '*'
    'ExtModeTrigType',                 'All',        'External Mode',      '*'
    'ExtModeTrigMode',                 'All',        'External Mode',      '*'
    'ExtModeTrigPort',                 'All',        'External Mode',      '*'
    'ExtModeTrigElement',              'All',        'External Mode',      '*'
    'ExtModeTrigDuration',             'All',        'External Mode',      '*'
    'ExtModeTrigHoldOff',              'All',        'External Mode',      '*'
    'ExtModeTrigDelay',                'All',        'External Mode',      '*'
    'ExtModeTrigDirection',            'All',        'External Mode',      '*'
    'ExtModeTrigLevel',                'All',        'External Mode',      '*'
    ... TEMPORARY EXCLUSION 'ExtModeCommand',                  'All',        'External Mode',      '*'
    'ExtModeUploadStatus',             'All',        'External Mode',      '*'
    'ExtModeParamVectName',            'All',        'External Mode',      '*'
    'ExtModeArchiveMode',              'All',        'External Mode',      '*'
    'ExtModeArchiveFileName',          'All',        'External Mode',      '*'
    'ExtModeArchiveDirName',           'All',        'External Mode',      '*'
    'ExtModeLastArchiveFile',          'All',        'External Mode',      '*'
    'ExtModeAutoIncOneShot',           'All',        'External Mode',      '*'
    'ExtModeIncDirWhenArm',            'All',        'External Mode',      '*'
    'ExtModeAddSuffixToVar',           'All',        'External Mode',      '*'
    'ExtModeWriteAllDataToWs',         'All',        'External Mode',      '*'
    'ExtModeArmWhenConnect',           'All',        'External Mode',      '*'
    'ExtModeSkipDownloadWhenConnect',  'All',        'External Mode',      '*'
    'ExtModeLogAll',                   'All',        'External Mode',      '*'
    'ExtModeLogCtrlPanelDlg',          'All',        'External Mode',      '*'
    'ExtModeConnected',                'All',        'External Mode',      '*'
    'ExtModeParamChangesPending',      'All',        'External Mode',      '*'
    'ExtModeNumTargetStepsPending',    'All',        'External Mode',      '*'
    'ExtModeAutoUpdateStatusClock',    'All',        'External Mode',      '*'
    ... RTWTarget only
    ... RTWBuildProcess
    'RTWSystemTargetFile',             'RTWTarget',  'RTWBuildProcess',   'SystemTargetFile'
    'RTWTemplateMakefile',             'RTWTarget',  'RTWBuildProcess',   'TemplateMakeFile'
    'RTWMakeCommand',                  'RTWTarget',  'RTWBuildProcess',   'MakeCommand'
    'RTWGenerateCodeOnly',             'RTWTarget',  'RTWBuildProcess',   'GenerateCodeOnly'
    'RTWRetainRTWFile',                'RTWTarget',  'RTWBuildProcess',   'RetainRTWFile'
    ...
    ... Parameters from the RTWOptions string
    ...
...    'RTWVerbose',                      'RTWTarget',  'RTWBuildProcess',   'VerboseBuild'
    ... RTWCommonOptions
...    'RTWSystemCodeInlineAuto',         'RTWTarget',  'RTWCommonOptions',  'SystemCodeInlineAuto'
...    'InlineInvariantSignals',          'RTWTarget',  'RTWCommonOptions',  '*'
...    'LocalBlockOutputs',               'RTWTarget',  'RTWCommonOptions',  '*'
...    'BufferReuse',                     'RTWTarget',  'RTWCommonOptions',  '*'
...    'RollThreshold',                   'RTWTarget',  'RTWCommonOptions',  '*'
...    'FoldNonRolledExpr',               'RTWTarget',  'RTWCommonOptions',  '*'
...    'EnforceIntegerDowncast',          'RTWTarget',  'RTWCommonOptions',  '*'
...    'IncHierarchyInIds',               'RTWTarget',  'RTWCommonOptions',  '*'
...    'ShowEliminatedStatements',        'RTWTarget',  'RTWCommonOptions',  '*'
...    'GenerateComments',                'RTWTarget',  'RTWCommonOptions',  '*'
...    'ForceParamTrailComments',         'RTWTarget',  'RTWCommonOptions',  '*'
...    'GenerateReport',                  'RTWTarget',  'RTWCommonOptions',  '*'
    ... TLC Debugging
    'TLCProfiler',                     'RTWTarget',  'TLCDebugging',      'Profiler'
    'TLCDebug',                        'RTWTarget',  'TLCDebugging',      'Debug'
    'TLCCoverage',                     'RTWTarget',  'TLCDebugging',      'Coverage'
    'TLCAssertion',                    'RTWTarget',  'TLCDebugging',      'Assertion'
    ...
    ... RTWOptions for specific RTW targets
    ...
    ... GRTOptions (from RTWOptions string)
...    'LogVarNameModifier',              'RTWTarget',  'GRTOptions',        '*'
...    'GenRTModel',                      'RTWTarget',  'GRTOptions',        '*'
...    'IgnoreCustomStorageClasses',      'RTWTarget',  'GRTOptions',        '*'
...    'ExtMode',                         'RTWTarget',  'GRTOptions',        '*'
...    'ExtModeTesting',                  'RTWTarget',  'GRTOptions',        '*' % hidden 
...    ... ERTOptions (from RTWOptions string)
...    'CombineOutputUpdateFcns',         'RTWTarget',  'ERTOptions',        '*' 
...    'CompactFilePackaging',            'RTWTarget',  'ERTOptions',        '*' 
...    'IncludeMdlTerminateFcn',          'RTWTarget',  'ERTOptions',        '*' 
...    'MatFileLogging',                  'RTWTarget',  'ERTOptions',        '*' 
...    'GenerateErtSFunction',            'RTWTarget',  'ERTOptions',        '*' 
...    'GenerateASAP2',                   'RTWTarget',  'ERTOptions',        '*' 
...    'PurelyIntegerCode',               'RTWTarget',  'ERTOptions',        '*' 
...    'ZeroExternalMemoryAtStartup',     'RTWTarget',  'ERTOptions',        '*' 
...    'ZeroInternalMemoryAtStartup',     'RTWTarget',  'ERTOptions',        '*' 
...    'InitFltsAndDblsToZero',           'RTWTarget',  'ERTOptions',        '*' 
...    'IgnoreCustomStorageClasses',      'RTWTarget',  'ERTOptions',        '*'  
...    'PrefixModelToStructs',            'RTWTarget',  'ERTOptions',        '*'  
...    'InsertBlockDesc',                 'RTWTarget',  'ERTOptions',        '*'  
...    'ExtMode',                         'RTWTarget',  'ERTOptions',        '*'  
...    'ExtModeTesting',                  'RTWTarget',  'ERTOptions',        '*' % hidden 
  };

% Model Parameters not included:
% 'Name',                            ''
% 'Tag',                             ''
% 'Description',                     ''
% 'Type',                            ''
% 'Parent',                          ''
% 'Handle',                          ''
% 'HiliteAncestors',                 ''
% 'RequirementInfo',                 ''
% 'Version',                         ''
% 'BlockDiagramType',                ''
% 'SampleTimeColors',                ''
% 'LibraryLinkDisplay',              ''
% 'WideLines',                       ''
% 'ShowLineDimensions',              ''
% 'ShowLineDimensionsOnError',       ''
% 'ShowPortDataTypes',               ''
% 'ShowPortDataTypesOnError',        ''
% 'ShowLoopsOnError',                ''
% 'IgnoreBidirectionalLines',        ''
% 'ShowStorageClass',                ''
% 'ExecutionOrder',                  ''
% 'ShowGrid',                        ''
% 'GridSpacing',                     ''
% 'Dirty',                           ''
% 'Lock',                            ''
% 'RecordCoverage',                  ''
% 'CovPath',                         ''
% 'CovSaveName',                     ''
% 'CovCompData',                     ''
% 'CovMetricSettings',               ''
% 'CovHTMLOptions',                  ''
% 'CovNameIncrementing',             ''
% 'CovHtmlReporting',                ''
% 'CovSaveCumulativeToWorkspaceVar', ''
% 'CovSaveSingleToWorkspaceVar',     ''
% 'CovCumulativeVarName',            ''
% 'CovCumulativeReport',             ''
% 'FixPtInfo',                       ''
% 'DataTypeOverride',                ''
% 'DataTypeOverride_Compiled',       ''
% 'MinMaxOverflowLogging',           ''
% 'MinMaxOverflowLogging_Compiled',  ''
% 'MinMaxOverflowArchiveMode',       ''
% 'MinMaxOverflowArchiveData',       ''
% 'ForwardingTable',                 ''
% 'ForwardingTableString',           ''
% 'BlockNameDataTip',                ''
% 'BlockParametersDataTip',          ''
% 'BlockDescriptionStringDataTip',   ''
% 'ToolBar',                         ''
% 'StatusBar',                       ''
% 'BrowserShowLibraryLinks',         ''
% 'BrowserLookUnderMasks',           ''
% 'PreLoadFcn',                      ''
% 'PostLoadFcn',                     ''
% 'PreSaveFcn',                      ''
% 'PostSaveFcn',                     ''
% 'CloseFcn',                        ''
% 'InitFcn',                         ''
% 'StartFcn',                        ''
% 'StopFcn',                         ''
% 'Browser',                         ''
% 'BrowserHandle',                   ''
% 'Created',                         ''
% 'Creator',                         ''
% 'UpdateHistory',                   ''
% 'ModifiedByFormat',                ''
% 'ModifiedBy',                      ''
% 'LastModifiedBy',                  ''
% 'ModifiedDateFormat',              ''
% 'ModifiedDate',                    ''
% 'LastModifiedDate',                ''
% 'ModifiedComment',                 ''
% 'ModifiedHistory',                 ''
% 'ModelVersionFormat',              ''
% 'ModelVersion',                    ''
% 'ConfigurationManager',            ''
% 'DataSet',                         ''
% 'FileName',                        ''
% 'SimParamPage',                    ''
% 'ResolveSignalLabels',             ''
% 'ForceConsistencyChecking',        ''
% 'ForceArrayBoundsChecking',        ''
% 'ForceModelCoverage',              ''
% 'LinearizationMsg',                ''
% 'SimulationMode',                  ''                                   
% 'Profile',                         ''
% 'RTWBuildArgs',                    '', % NEVER_SAVE
% 'RTWGenSettings',                  '', % NEVER_SAVE
% 'AccelSystemTargetFile',           ''
% 'AccelTemplateMakefile',           ''
% 'AccelMakeCommand',                ''
% 'TryForcingSFcnDF',                ''
% 'AnalyticLinearization',           ''
% 'UseAnalysisPorts',                ''
% 'DisplayCondStIdTree',             ''
% 'DisplayCondInputTree',            ''
% 'DisplaySortedLists',              ''
% 'DisplayErrorDirections',          ''
% 'DisplayInvisibleSources',         ''
% 'DisplayBlockIO',                  ''
% 'DisplayVectorAndFunctionCounts',  ''
% 'DisplayBdSearchResults',          ''
% 'DisplayVectPropagationResults',   ''
% 'DisplayCompileStats',             ''
% 'SimulationStatus',                ''
% 'SimulationTime',                  ''
% 'Jacobian',                        ''
% 'SimulationCommand',               ''
% 'Location',                        ''
% 'Open',                            ''
% 'ScrollbarOffset',                 ''
% 'ModelBrowserVisibility',          ''
% 'ModelBrowserWidth',               ''
% 'ScreenColor',                     ''
% 'CurrentBlock',                    ''
% 'CurrentOutputPort',               ''
% 'Blocks',                          ''
% 'Lines',                           ''
% 'DeleteChildFcn',                  ''
% 'PaperOrientation',                ''
% 'PaperPosition',                   ''
% 'PaperPositionMode',               ''
% 'PaperType',                       ''
% 'PaperSize',                       ''
% 'PaperUnits',                      ''
% 'ZoomFactor',                      ''
% 'ReportName',                      ''

% PARAMETER TO REMOVE: 'RTWExpressionDepthLimit'
