function simParamMap = simprmtagmap
%SIMPARAMTAGMAP  Define the mapping from a model's
%   simulation parameters to Simulation Parameter Dialog's ui item.

%   Copyright 2002 The MathWorks, Inc.
%   $Revision: 1.1.6.1 $  $Date: 2002/09/23 16:29:56 $

simParamMap = {
    'StartTime',           'Solver'
    'StopTime',            'Solver'
    'Solver',              'Solver'
    'SolverMode',          'Solver'
    'RelTol',              'Solver'
    'AbsTol',              'Solver'
    'FixedStep',           'Solver'
    'MaxStep',             'Solver'
    'InitialStep',         'Solver'
    'MinStep',             'Solver'
    'MaxNumMinSteps',      'Solver'
    'MaxOrder',            'Solver'
    'OutputOption',        'Solver'
    'OutputTimes',         'Solver'
    'Refine',              'Solver'
    ... Workspace IO
    'LoadExternalInput',   'WorkspaceIO'
    'ExternalInput',       'WorkspaceIO'
    'LoadInitialState',    'WorkspaceIO'
    'InitialState',        'WorkspaceIO'
    'SaveTime',            'WorkspaceIO'
    'TimeSaveName',        'WorkspaceIO'
    'SaveState',           'WorkspaceIO'
    'StateSaveName',       'WorkspaceIO'
    'SaveOutput',          'WorkspaceIO'
    'OutputSaveName',      'WorkspaceIO'
    'SaveFinalState',      'WorkspaceIO'
    'FinalStateName',      'WorkspaceIO'
    'SaveFormat',          'WorkspaceIO'
    'LimitDataPoints',     'WorkspaceIO'
    'MaxDataPoints',       'WorkspaceIO'
    'Decimation',          'WorkspaceIO'
    ... Diagnostics
    'ConsistencyChecking',            'Diagnostics'
    'ArrayBoundsChecking',            'Diagnostics'
    'AlgebraicLoopMsg',               'Diagnostics'
    'BlockPriorityViolationMsg',      'Diagnostics'
    'MinStepSizeMsg',                 'Diagnostics'
    'InheritedTsInSrcMsg',            'Diagnostics'
    'DiscreteInheritContinuousMsg',   'Diagnostics'
    'MultiTaskRateTransMsg',          'Diagnostics'
    'SingleTaskRateTransMsg',         'Diagnostics'
    'CheckForMatrixSingularity',      'Diagnostics'
    'IntegerOverflowMsg',             'Diagnostics'
    'Int32ToFloatConvMsg',            'Diagnostics'
    'ParameterDowncastMsg',           'Diagnostics'
    'ParameterOverflowMsg',           'Diagnostics'
    'ParameterPrecisionLossMsg',      'Diagnostics'
    'UnderSpecifiedDataTypeMsg',      'Diagnostics'
    'UnnecessaryDatatypeConvMsg',     'Diagnostics'
    'VectorMatrixConversionMsg',      'Diagnostics'
    'InvalidFcnCallConnMsg',          'Diagnostics'
    'SignalLabelMismatchMsg',         'Diagnostics'
    'UnconnectedInputMsg',            'Diagnostics'
    'UnconnectedOutputMsg',           'Diagnostics'
    'UnconnectedLineMsg',             'Diagnostics'
    'SfunCompatibilityCheckMsg',      'Diagnostics'
    ... Advanced                       
    'RTWInlineParameters',            'Advanced'
    'BlockReductionOpt',              'Advanced'
    'BooleanDataType',                'Advanced'
    'ConditionallyExecuteInputs',     'Advanced'
    'ParameterPooling',               'Advanced'
    'OptimizeBlockIOStorage',         'Advanced'
    'ZeroCross',                      'Advanced'
    'AssertionControl',               'Advanced'
    'ProdHWDeviceType',               'Advanced'
    'ProdHWWordLengths',              'Advanced'
    ... RTWBuildProcess
    'RTWSystemTargetFile',           'RTW' 
    'RTWTemplateMakefile',           'RTW'
    'RTWMakeCommand',                'RTW'
    'RTWGenerateCodeOnly',           'RTW' 
    'RTWRetainRTWFile',              'RTW'
    'RTWSystemCodeInlineAuto',       'RTW'
    'BufferReuse',                   'RTW'
    'RTWOptions',                    'RTW'
    ... TLC Debugging
    'TLCProfiler',                   'ProfileTLCCheckbox'
    'TLCDebug',                      'TLCDebugCheckbox'
    'TLCCoverage',                   'TLCCoverageCheckbox'
    'TLCAssertion',                  'TLCAssertionCheckbox'
  };

